Download it now!
Bug 108642 - FILEOPEN: document with a complex table structure takes double the time to open when the sidebar is enabled (gtk3)
Summary: FILEOPEN: document with a complex table structure takes double the time to op...
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
4.4 all versions
Hardware: All Linux (All)
: medium normal
Assignee: Not Assigned
URL:
Whiteboard: target:6.5.0 target:6.4.0.1
Keywords: bibisected, bisected, haveBacktrace, perf, regression
Depends on:
Blocks: Writer-Tables File-Opening gtk3-whipping-boy
  Show dependency treegraph
 
Reported: 2017-06-19 23:37 UTC by Xisco Faulí
Modified: 2019-11-27 15:50 UTC (History)
6 users (show)

See Also:
Crash report or crash signature:


Attachments
Callgrind output from master (6.27 MB, application/x-xz)
2017-06-20 13:25 UTC, Buovjaga
Details
perf flamegraph (204.93 KB, application/x-bzip)
2019-11-08 21:04 UTC, Julien Nabet
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Xisco Faulí 2017-06-19 23:37:34 UTC
Steps to reproduce:
1. Open attachment 133874 [details] from bug 108361

In

Version: 5.3.3.2
Build ID: 1:5.3.3~rc2-0ubuntu0.16.10.1~lo0
CPU Threads: 4; OS Version: Linux 4.8; UI Render: default; VCL: gtk3; Layout Engine: new; 
Locale: ca-ES (ca_ES.UTF-8); Calc: group

without the sidebar it takes

real	2m10.252s
user	2m5.484s
sys	0m0.188s

while with the sidebar

real	6m6.350s
user	6m5.812s
sys	0m0.204s
Comment 1 Xisco Faulí 2017-06-19 23:42:12 UTC
Regression introduced by:

author	Samuel Mehrbrodt <s.mehrbrodt@gmail.com>	2014-08-22 20:37:56 (GMT)
committer	Thomas Arnhold <thomas@arnhold.org>	2014-08-24 11:26:17 (GMT)
commit	b4558b508141af16d335f45a0f12bdd34521e944 (patch)
tree	f8479fe8131a0d1677100e2cc16c244e860189cb
parent	a75e0f8e4e5f0baa5805d01c5f8edc7b40fceb0f (diff)
fdo#73151 Make better use of the sidebar
The general idea is to encourage use of the sidebar instead of floating windows (for Navigator, Styles&Formatting and Gallery)

Changes:
* Show the sidebar by default in Writer & Impress
* Remove the Gallery floating window (Gallery now always opens in the sidebar)
* Remove all Gallery, Navigator and Styles&Formatting links from the default toolbar in Writer
  (since they have an icon in the sidebar and the sidebar is shown by default now)
* When selecting "More" from the Styles dropdown, the Stylelist opens in the sidebar instead of the floating window

Bisected with bibisect-44max

Adding Cc: to Samuel Mehrbrodt

In

Version: 4.4.0.0.alpha0+
Build ID: b4558b508141af16d335f45a0f12bdd34521e944

it takes

real	4m17.950s
user	4m11.596s
sys	0m0.400s

while in

Version: 4.4.0.0.alpha0+
Build ID: a75e0f8e4e5f0baa5805d01c5f8edc7b40fceb0f (Previous Commit )

it takes 

real	1m47.564s
user	1m39.744s
sys	0m0.444s
Comment 2 Xisco Faulí 2017-06-19 23:43:58 UTC
It seems to open in just a few seconds in

Versión: 5.3.3.2
Id. de compilación: 3d9a8b4b4e538a85e0782bd6c2d430bafe583448
Subproc. CPU: 1; SO: Windows 6.1; Repr. de IU: predet.; Motor de trazado: HarfBuzz; 
Configuración regional: es-ES (es_ES); Calc: group

Thus, Linux only
Comment 3 Buovjaga 2017-06-20 13:25:22 UTC
Created attachment 134161 [details]
Callgrind output from master

Arch Linux 64-bit, KDE Plasma 5
Version: 6.0.0.0.alpha0+
Build ID: d6c4c576ef71f2294ec8eefc6576a797220e6809
CPU threads: 8; OS: Linux 4.11; UI render: default; VCL: kde4; 
Locale: fi-FI (fi_FI.UTF-8); Calc: group
Built on June 18th 2017
Comment 4 QA Administrators 2018-06-21 02:51:30 UTC Comment hidden (obsolete)
Comment 5 Roman Kuznetsov 2019-02-02 20:36:21 UTC
it takes 8 sec with Sidebar in

Версия: 6.3.0.0.alpha0+
ID сборки: 51af3179cf972809d6495c7d58033e069f647bbf
Потоков ЦП: 4; ОС:Linux 4.18; Отрисовка ИП: по умолчанию; VCL: kde5; 
TinderBox: Linux-rpm_deb-x86_64@86-TDF, Branch:master, Time: 2019-02-01_00:15:00
Локаль: ru-RU (ru_RU.UTF-8); UI-Language: ru-RU
Calc: threaded

Kubuntu 18.10

Xisco, WFM or not?
Comment 6 Xisco Faulí 2019-11-08 15:34:54 UTC
it takes 

real	0m43,180s
user	0m41,881s
sys	0m1,276s

with the sidebar expanded in

Version: 6.4.0.0.alpha1+
Build ID: 498c2d3944b666c2f016b65903001920db2cb2a4
CPU threads: 4; OS: Linux 4.15; UI render: default; VCL: gtk3; 
Locale: ca-ES (ca_ES.UTF-8); UI-Language: en-US
Calc: threaded

while in

Version: 6.4.0.0.alpha1+
Build ID: 498c2d3944b666c2f016b65903001920db2cb2a4
CPU threads: 4; OS: Linux 4.15; UI render: default; VCL: x11; 
Locale: ca-ES (ca_ES.UTF-8); UI-Language: en-US
Calc: threaded

it takes

real	0m4,084s
user	0m3,603s
sys	0m0,353s

@Julien, could you please make a perf chart out of this ?
Comment 7 Caolán McNamara 2019-11-08 16:22:36 UTC
I'd guess its an accessibility thing rather than a gtk3 thing, just that a11y is on by default with gtk3
Comment 8 Julien Nabet 2019-11-08 21:04:08 UTC
Created attachment 155642 [details]
perf flamegraph

On pc Debian x86-64 with master sources updated today, I retrieved a Flamegraph
Comment 9 Xisco Faulí 2019-11-09 14:41:34 UTC
(In reply to Julien Nabet from comment #8)
> Created attachment 155642 [details]
> perf flamegraph
> 
> On pc Debian x86-64 with master sources updated today, I retrieved a
> Flamegraph

@Noel, I thought you might be interested in this issue...
Comment 10 Commit Notification 2019-11-27 05:40:30 UTC
Noel Grandin committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/4edf078a77167d0fb5201f857146d95a901a809e

tdf#108642 simplify comparison data calculation

It will be available in 6.5.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 11 Commit Notification 2019-11-27 06:45:32 UTC
Noel Grandin committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/28ea418a3f1905d8a4a8e5813e8ed737960c62d2

tdf#108642 rate-limit progress painting

It will be available in 6.5.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 12 Commit Notification 2019-11-27 07:26:05 UTC
Noel Grandin committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/b4494f276795d1bb419d258ed0b2ec33c92c7290

tdf#108642 remove dynamic_cast

It will be available in 6.5.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 13 Commit Notification 2019-11-27 09:30:00 UTC
Noel Grandin committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/980c859480be431311ba803c5251694160dcb3d5

tdf#108642 load accessibility children faster

It will be available in 6.5.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 14 Xisco Faulí 2019-11-27 10:33:05 UTC
it takes

real	0m15,832s
user	0m15,544s
sys	0m0,248s

in

Version: 6.5.0.0.alpha0+
Build ID: 3a6f270edfffb97763927b2732feacedbdac1e80
CPU threads: 4; OS: Linux 4.15; UI render: default; VCL: gtk3; 
Locale: ca-ES (ca_ES.UTF-8); UI-Language: en-US
Calc: threaded

Nicee!!!
@Noel, thanks for fixing this issue!
Comment 15 Commit Notification 2019-11-27 13:18:05 UTC
Noel Grandin committed a patch related to this issue.
It has been pushed to "libreoffice-6-4":

https://git.libreoffice.org/core/commit/f4b128f0d607fa74c9a62744753beff497dd0fc3

tdf#108642 simplify comparison data calculation

It will be available in 6.4.0.1.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 16 Commit Notification 2019-11-27 14:12:24 UTC
Noel Grandin committed a patch related to this issue.
It has been pushed to "libreoffice-6-4":

https://git.libreoffice.org/core/commit/8bb1e1e1beee149af21b9a28ede62c987c85bd9a

tdf#108642 remove dynamic_cast

It will be available in 6.4.0.1.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 17 Commit Notification 2019-11-27 15:50:12 UTC
Noel Grandin committed a patch related to this issue.
It has been pushed to "libreoffice-6-4":

https://git.libreoffice.org/core/commit/78400d8f0b3906f9835b0cbb70a907625f213ebf

tdf#108642 rate-limit progress painting

It will be available in 6.4.0.1.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 18 Commit Notification 2019-11-27 15:50:31 UTC
Noel Grandin committed a patch related to this issue.
It has been pushed to "libreoffice-6-4":

https://git.libreoffice.org/core/commit/6b5c7f8e5eb548b25c6119fe10cd8919f5275274

tdf#108642 load accessibility children faster

It will be available in 6.4.0.1.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.